\documentclass[12pt,notitlepage]{report}
%\pagestyle{headings}
\pagestyle{plain}

\frenchspacing % aktivuje použití některých českých typografických pravidel
\usepackage{a4wide} % nastavuje standardní evropský formát stránek A4

%\usepackage[left=4cm, right=2.5cm, top=3cm, bottom=3cm]{geometry} % nastavení dané velikosti okrajů
\usepackage[utf8]{inputenc}
\usepackage[english]{babel}
%\usepackage{index} % nutno použít v případě tvorby rejstříku balíčkem makeindex
%\usepackage{fancybox} % umožňuje pokročilé rámečkování :-)
\usepackage{wrapfig}
\usepackage[dvips]{graphicx} % nezbytné pro standardní vkládání obrázků do dokumentu
\usepackage{url}

\begin{document}
\begin{titlepage}
\begin{center}
\ \\

\vspace{15mm}

{\Large\bf Obr Developers Documentation}

\vspace{10mm}

{\Large Josef Moudřík}\\
\vspace{5mm}
{\Large\bf Obr - OpenGL based image viewer}\\ 
\end{center}
\vspace{15mm}

\begin{center}
2009 
\end{center}
\end{titlepage}

\setcounter{page}{2} % nastavení číslování stránek

\tableofcontents

\chapter{Introduction}
Obr is supposed to be an image viewer for Linux. Its main goals are to be fast,
have support for a various image formats and be simple to use. Moreover, I wanted it to be general enough to
display various meta information, such as text, thumbnails or some other image data.

\chapter{Analysis}
This version of Obr is based on my previous image viewer. It was also based on opengl, to make it fast, and it turned out
that this choice was very lucky. Once an image was loaded, user experience was very fast and the image displaying was very eye pleasant.
The previous version of Obr was however suffering a major user-interface slowdown when loading large photo datas. This was because of
a single-threaded design, that did not allow for slow io to run in the background. I concluded that in order to get rid of the problem
the application should have at least two concurrent threads, the extra one needed for costly input-output operations.

The use of Imlib library for loading data was lucky, it is pretty fast and has a support for various input formats. So we want to separate
image loading into a single thread.

Unlike in previous version, which used SDL, I decided to get rid of it and once I use OGL, why not to use GLUT toolkit as well. Since OpenGL
(and neither the glut) are thread safe, one must either lock the gl himself, or run all opengl-stuff in a single thread. I chose the second
solution, since I think that OGL stuff like drawing takes a lot of time and thus locking would not make any speedup (one thread would always
be locked and waiting until the other finishes) and since profiling showed that OGL consumes practically all the cpu-time itself, another
level of concurrency during program load would be of no use.

Having two threads implies for a safe-but-fast mutexed data structures to share the loading data. I decided to make the communication general,
each thread having its input mutexed queue that the other can assign jobs (communication primitives) to. And since we dont want the queues
to carry huge amount of data that would need to be copyied, I also decided to have locked structures that keep the image data. 

In order to prevent long lasting lock during intensive io, I present a concept of lockable state object. It has properties that every thread
may quickly (thread-safely) investigate its state and if it is one that allows for the thread to act, the thread would state it uses it and
because of the program consistency, the other thread would respect the fact while not hanging on a lock.

This basically means that each image data structure has a state variable and state mutex, that locks not the object itself but the very state
variable. All the threads now need to do is to lock a state variable, check a state and if it is the one they are interested in (e.g the image
is not loaded yet) change it and unlock the variable. Since the thread changed a state to saying "Work in progress" it can do its work while the
other thread is always free to check the state and if it sees there is someone working there it may skip it and mind its own bussiness.

Further, because we probably will be seeing large photo albums, we want to emloy some good image loading policy. To ensure, that we 
do not hold images that have not been used recently (or have not been used at all), I propose a policy based on Aging.
\section{Design goals}
What must be done, or what features will the program have
\begin{enumerate}
\item \textbf{Two threads} - one loading images from the disk, the other doing basically all the other stuff using GLUT and OPENGL.
\item \textbf{Two mutexed jobs queues} - For fast communication between threads.
\item \textbf{Mutexed Image data structures} - Minimizing time of wait-for-a-lock situation.
\item \textbf{Good image loading policy} - Forecasting image that will probably be shown, whili minimizing memory usage.
\item \textbf{Object oriented approach} - To maximize the code-reusing and encapsulation.
\end{enumerate}

\chapter{Design and implementation}
\begin{center}
\includegraphics[width=\textwidth]{obr.eps}
\end{center}

\section{Threading data structures}
For the two threads to properly communicate, a proper structures must be designed.
\subsection{Mutexed job queues}
See \url{threading.h}, classes \url{TaskMutexQueue}, and \url{Task}.

The first of the data structures used to interthread communication is a mutexed job queue. Each thread will have its input queue and
if needed, it will have input queue of the other thread to give the results back. (We can think of those results just as another job for
the other thread). Because the motivation behind the job queues was an image loading, we must respect it in the design. Sometimes we want
to load some image before another, so I decided that the queue would have priorities. To implement it I wrapped standart STL prio queue with
boost's mutexes to create a robust mutexed solution.

The queues were designed to hold pointers to a common \textbf{Task class}, that acts as an ancestor for all tasks. The task class is designed
to have a "signal" integer inside signalling what type of content is in the Task.

\subsection{Mutexed State Object}
See \url{threading.h}, classes \url{StateObject}.

As noted before, to be able to work with a data structure while other threads do not have to wait for lock, I introduced a concept of State
Objects. \url{StateObject} is a class with mutexed state variable, where states have defined meanings. In obr States indicate what ImageData
are loaded, see section \textbf{ImageData}
\section{Working thread}
See \url{threading.h}, classes \url{ThreadWorker} and \url{Task}.

Is a second thread that is very simple. In the loop it checks its job queue and if it is not-empty it does the \url{Task}.

\section{Image Data Structures}
See \url{image.h}, classes \url{Slide}, \url{ImageData}, \url{ImlibData} and \url{TextureData}.

\subsection{Slides concept}
\begin{center}
\includegraphics[scale=0.5]{slide.eps} 
\end{center}
See \url{image.h}, classes \url{Slide}.

As I mentioned above, each photo may have various data attached to it. These may be histogram, thumbnail, text. I call this "pack" a slide.
A slide has two types of information. It contains \url{ImageData} such as histogram, thumbnail or the photo itself (called  Image), text,
information about rotation.

\subsection{ImageData}
\begin{center}
\includegraphics[scale=0.5]{imagedata.eps} 
\end{center}
See \url{image.h}, classes \url{ImageData}, \url{ImlibData} and \url{TextureData}.

Is an object handling image date, be it either empty, holding only raw ImlibData, or even have assigned GL texture number TextureData.
According to its content its state is set properly.

\section{Main Object}
See \url{main.cpp}, \url{main_obj.h},\url{main_obj.cpp} classes \url{MainObj}, \url{mlibData} and \url{TextureData}.

Is a main object handling keys, drawing, loading GL textures. It is called by the glut as set up in the \url{main.cpp}. The glut calls its
methods through the following functions.
\begin{list}{}
\item \textbf{glut\_idle\_func} - When glut has nothing to do.
\item \textbf{glut\_reshape} - When the window needs to be reshaped.
\item \textbf{glut\_keyboard actions} - When there is a keyboard input.
\item \textbf{glut\_draw} - When the window needs to be redrawed.
\end{list}

The Main object also holds the faces that draw the content, these are InfoFace, ThumbnailFace and ImageFace (see below).
\subsection{glut\_idle\_func}
When glut has nothing to do, it calls this function. In this function our main thread does quite a few things. It redraws the screen.
If there is an opengl texture to be load, it loads it (it gets it via the \url{result\_queue} from the second thread) And it performs movement
of to the next images or to the thumbnail view.

\subsection{glut\_reshape}
When the screen reshapes images that are drawn need to recompute their coordination. This is done in each face that draw the content so
Main only propagates the reshape event to InfoFace, ThumbnailFace and ImageFace.

Furthermore, proper GL camera setting and similar stuff needs to be done.

\subsection{glut\_keyboard actions}
When the keyboard is pressed the Main basically moves in the vector of slides, initializes a transitions, updates image faces (e.g. move
in the thumbnail face).

\subsection{glut\_draw}
A main drawing function. All it basically does is that it sets up camera during the transition and tels the Faces (ImageFace, ThumbnailFace
and InfoFace) to draw their content.

\section{Faces}
See \url{face.h},\url{thumbnail_face.h}, \url{image_face.h}, \url{info_face.h} and classes \url{Face}, \url{ImageFace}, \url{InfoFace} and
\url{ThumbnailFace}.

Faces are objects descending from the basic \url{Face} object. Their main task is to draw the image content on the screen. Thumbnail face
draws thumbnails, ...

\chapter{Aging and image loading policies}
See \url{main_obj.h} and \url{main_obj.cpp} classes \url{Main} and \url{ImageData}.
To maximize the user comfort, we should load images, that will be probably shown in a short time. Meanwhile, because usually photos are very
large, we do not want to keep data not used in the memory.
\section{Aging}
To achieve a second goal, I implemented image aging. Each ImageData has an unsigned value called age. Every 500 ms we add 1 to age of all
images. And every time an image is used (for drawing) we reset the age to 0. And, every 500 ms, we do the freeing. When the age of an image
is 5, we free its TextureData, since this can be very fastly recomputed from raw ImlibData. When the age is over 15, we remove the ImlibData
as well.  To reflect the fact that thumbnails are (should be) smaller, and we want to have them as long as possible, we remove thumbnails'
TextureData after 60 and ImlibData after 180 age clocks.
\section{Image loading policy}
To predict what the user will want to see, we use pretty simple politics. We load images around the current one, 2 images in the direction
of last movement and 1 in the opposite, with priorities so that closer images will be loaded before those that are more far away.

\chapter{Input parser}
See \url{input_parser.h} and \url{input_parser.cpp} classes \url{Parser}.
Input parser is the first thing that is run when Obr starts. The Parser itself is a very straightforward state machine.

The input parser distincts two blocks that have starting/closing parenthesis and a number of primitives. The primitives are either one-line
or two line pairs, that either interpret the second line as number or texts. The two blocks are
\begin{verbatim}
BeginSlide
...
EndSlide
\end{verbatim}
and
\begin{verbatim}
BeginOptions
...
EndOptions
\end{verbatim}
The first one is used to define a new Slide, the second to set up the options.

\section{Slide Block}
Inside the slide block, there might be a number of one line tags:
\begin{verbatim}
Rotation0
Rotation90
Rotation180
Rotation270
Marked1
Marked0
\end{verbatim}
The first four set the Rotation of the image, the Marked0 or Marked1 tags specify whether the slide is marked :-)

Apart from one-line blocks, there are other tags that expect text on the next line as their argument, these are
\begin{verbatim}
Image
Thumbnail
Histogram
Text
\end{verbatim}
The first 3 specify images, the Text tag describes meta text to be displayed with the image.

So a sample slide input might look like:
\begin{verbatim}
BeginSlide
Rotation180
Image
./granny.jpg
Thumbnail
./.thumbnails/granny.jpg
Histogram
./.histograms/granny.jpg
Text
My granny at the market!
EndSlide
\end{verbatim}
Once loaded, this slie block will result in showing your granny upside down.
\section{Options Block}
See \url{options.h} for details.
The options block also has some one-line tags, these are
\begin{verbatim}
TransitionSmooth
TransitionSkip
MaxTextureSize512
MaxTextureSize1024
MaxTextureSize2048
MaxTextureSize4096
Verbose0
Verbose1
\end{verbatim}
Setting transition, GL texture size and verbosity.

Apart from interpret-next-line-as-text-argument tag:
\begin{verbatim}
Font
\end{verbatim}
there are others that interpret the next line as a number param. These are:
\begin{verbatim}
SlideshowDelay
FontSize
BorderSize
MinThumbnailSize
RotationDelay
\end{verbatim}
In the end, a sample options block might look like:
\begin{verbatim}
BeginOptions
TransitionSmooth
MaxTextureSize1024
Verbose0
FontSize
48
BorderSize
20
MinThumbnailSize
256
RotationDelay
300
EndOptions
\end{verbatim}
For details see the header file \url{options.h}.

\chapter{Future work}
When I was designing Obr, I thought that the input parsing would take just a few ms, but it turns out it does not, so it would be nice to
add another thread to parse the input while showing what we have loaded already. But first, I will try to speed up the wrapping shell scripts
and so, and investigate other influences.

\appendix
\chapter{Object Hiearchy}
\begin{verbatim}
main_obj.h             class Main
threading.h            class ThreadWorker
threading.h            class priority_mutex_queue 
options.h              class Options
input_parser.h         class Parser
faces.h                class Face
image_face.h                |- class ImageFace: public Face
info_face.h                 |- class InfoFace: public Face
thumbnail_face.h            |- class ThumbnailFace: public Face
faces.h                struct Position
faces.h                struct FTPosition
threading.h            class Task
image.h                     |- class TaskImageContainer:public Task
image.h                     |- class TaskImageLoadImlib:public Task
threading.h            class StateObject
image.h                     |- class ImageData: public StateObject
image.h                struct ImlibData 
image.h                struct TextureData 
image.h                struct Slide
options.h              struct KeyReturn
job_manager.h          class JobManager
FTfont lib             class FTfont
\end{verbatim}


\chapter{Class Member Hiearchy}
\begin{verbatim}
main.cpp               (main thread)
   |- class Options                       global_options
   |- class Parser                        parser
   |- class priority_mutex_queue          job_queue, result_queue ---<---+
         |- class Task                                                   |
               |- class TaskImageContainer                               |
               |- class TaskImageLoadImlib                               |
   |- class Main                          main_obj                       |
         |- class FTfont                 *ft_font --------<---------+    |
         |- class ImageFace              *imf,*imf_left,*imf_right  |    |
               |- class FTfont           *ft_font -------->---------+    |
               |- struct Position        *image_pos,*histogram_pos  |    |
               |- struct FTPosition      *ft_pos,*marked_pos        |    |
         |- class InfoFace                inff                      |    |
               |- class FTfont           *ft_font -------->---------+    |
               |- struct FTPosition      *info_pos,*slide_pos            |
         |- class ThumbnailFace           tmf                            |
               |- class JobManager      & job_manager -->-+              |
         |- class JobManager              job_manager --<-+              |
         |- class priority_mutex_queue  & job_queue, & result_queue ->---+
                                                                         |
thread     class ThreadWorker        SECOND THREAD                       |
   |- class priority_mutex_queue        & in_job_queue, &out_job_queue ->+
\end{verbatim}


\end{document}
